unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    btn_start: TButton;
	pattern: TComboBox;
	rb_border: TRadioButton;
	rb_sborder: TRadioButton;
    btn_ende: TButton;
    grd: TStringGrid;
	Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Bevel1: TBevel;
    grd2: TStringGrid;
    Label4: TLabel;
    _text: TComboBox;
    Label5: TLabel;
    btn_suche: TButton;
    Label6: TLabel;
    Label7: TLabel;
	procedure btn_startClick(Sender: TObject);
	procedure FormCreate(Sender: TObject);
    procedure btn_endeClick(Sender: TObject);
    procedure patternChange(Sender: TObject);
    procedure _textChange(Sender: TObject);
    procedure btn_sucheClick(Sender: TObject);
  private
	{ Private-Deklarationen }
  public
	{ Public-Deklarationen }
  end;

var
  Form1: TForm1;
	pat: array[1..25] of String;
	border: array[1..25] of Integer;
	sborder: array[1..25] of Integer;
	m: Integer;							// die Patternlnge

	grd_zeile: Integer;                 // Zeile, an der ausgegeben wird

implementation

{$R *.DFM}

function max(i, j: Integer): Integer;
begin
	if i > j then Result := i else Result := j;
end;

procedure _border;
var i, j(*, m*): Integer;
begin
	border[1] := 0;
	for j:=2 to m do border[j]:=1;
	i := 2;
	j := 1;
	while i <= m do begin
		while ((i+j-1 <= m) and (pat[j] = pat[i+j-1])) do begin
			j := j+1;
			if i+j-1 <= m then
				border[i+j-1] := j;
		end;
//	   if i+j-1 <= m then
//		  sborder[i+j-1] := max(j, sborder[i+j-1]);
		i := i+j-border[j];
		j := max(border[j], 1);
	end;
end;

procedure _sborder;
var i, j(*, m*): Integer;
begin
	for j:=1 to m do sborder[j]:=0;
	j := 1;
	i := 2;
	while i <= m do begin
	   while ((i+j-1 <= m) and (pat[j] = pat[i+j-1])) do begin
		  j := j+1;
		  if i+j-1 <= m then
			 sborder[i+j-1] := sborder[j];
	   end;
	   if i+j-1 <= m then
		  sborder[i+j-1] := max(j, sborder[i+j-1]);
	   i := i+j-sborder[j];
	   j := max(sborder[j], 1);
	end;
end;

(**
	Parameter: Typ => 0 = border, 1 = sborder
*)
function suche(text: String; pattern: String; grd2: TStringGrid; typ: Integer): Integer;
var i, j, s: Integer;
begin
	i := 1;
	j := 1;
	s := 0;
	while ((s+i) <= Length(text)) and (j < Length(pattern)+1) do begin
		if Copy(text,s+i,1) = Copy(pattern,j,1) then begin
			grd2.Cells[(s+i)-1,grd_zeile] := Copy(pattern,j,1);

			i := i + 1;
			j := j + 1;
		end
		else begin
			if (typ = 0) then s := s + (j - border[j]);
			if (typ = 1) then s := s + (j - sborder[j]);
			i := 1;
			j := 1;

			grd_zeile := grd_zeile + 1;
			grd2.Cells[(s+i)-1,grd_zeile] := Copy(pattern,j,1);
			grd2.RowCount := grd2.RowCount+1;
		end;
	end;
	if j = Length(pattern)+1 then Result := s else Result := -1;
end;

procedure TForm1.btn_startClick(Sender: TObject);
var i: Integer;
begin
	grd_zeile := 1;

	// lesen
	m := length(pattern.Text);
	for i := 1 to m do
		pat[i] := Copy(pattern.Text,i,1);

	// Algorithmus/en
	_border;
	_sborder;

	// schreiben
	grd.RowCount := 3;
	for i := 0 to m-1 do begin
		grd.Cells[i,1] := IntToStr(border[i+1]);
		grd.Cells[i,2] := IntToStr(sborder[i+1]);
	end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	pattern.Items.Add('abacabaccaba');
	pattern.Items.Add('abaababaabaab');
	_text.Items.Add('abacabcabacabaccaba');
	grd.RowCount := 1;
//	grd.ColCount := 12;
	patternChange(nil);
end;

procedure TForm1.btn_endeClick(Sender: TObject);
begin
	Close;
end;

procedure TForm1.patternChange(Sender: TObject);
var i: Integer;
begin
	grd.ColCount := Length(pattern.Text);
	for i := 0 to Length(pattern.Text)-1 do
		grd.Cells[i,0] := Copy(pattern.Text,i+1,1);
end;

procedure TForm1._textChange(Sender: TObject);
var i: Integer;
begin
	grd2.ColCount := Length(_text.Text);
	for i := 0 to Length(_text.Text)-1 do
		grd2.Cells[i,0] := Copy(_text.Text,i+1,1);
end;

procedure TForm1.btn_sucheClick(Sender: TObject);
var i,j, _pos: Integer;
begin
	with grd2 do								// Grid lschen
		for i := 0 to ColCount - 1 do
			for j := 1 to RowCount - 1 do		// 1. Zeile stehen lassen
				Cells[i, j] := '';

	grd_zeile := 1;
	grd2.RowCount := 2;
	if (rb_border.Checked) then _pos := suche(_text.Text, pattern.Text,grd2, 0)
		else _pos := suche(_text.Text, pattern.Text,grd2, 1);
//	grd2.RowCount := grd2.RowCount-1;
	if _pos >= 0 then Label6.Caption := 'gefunden an Pos.: ' + IntToStr(_pos+1)
		else Label6.Caption := 'nicht gefunden';
	Label7.Caption := 'Versuche: ' + IntToStr(grd_zeile);
end;

end.
